class Rechteck {
	int x;
	int y;
	int weite;
	int hoehe;
}

public class UE9Aufgabe14 {

	static Rechteck getUmfassendesRechteck(Rechteck r1, Rechteck r2) {
		Rechteck erg = new Rechteck();
		erg.x = min(r1.x, r2.x);
		erg.y = min(r1.y, r2.y);
		erg.weite = max(r1.x + r1.weite, r2.x + r2.weite) - erg.x;
		erg.hoehe = max(r1.y + r1.hoehe, r2.y + r2.hoehe) - erg.y;
		return erg;
	}

	static int min(int v1, int v2) {
		return v1 < v2 ? v1 : v2;
	}

	static int max(int v1, int v2) {
		return v1 > v2 ? v1 : v2;
	}

	public static void main(String[] args) {
		Rechteck r1 = initRechteck();
		Rechteck r2 = initRechteck();

		Rechteck r3 = getUmfassendesRechteck(r1, r2);
		print(r3);
	}

	static Rechteck initRechteck() {
		Rechteck r = new Rechteck();
		IO.println("Rechteck eingeben:");
		r.x = IO.readInt("x: ");
		r.y = IO.readInt("y: ");
		r.weite = IO.readInt("width: ");
		r.hoehe = IO.readInt("height: ");
		return r;
	}

	static void print(Rechteck r) {
		System.out.println("Rechteck ausgeben:");
		System.out.println("x = " + r.x);
		System.out.println("y = " + r.y);
		System.out.println("width = " + r.weite);
		System.out.println("height = " + r.hoehe);
	}

}
