// https://de.wikipedia.org/wiki/Y2K-Spiel

class Spielzug {
	int index;
	char buchstabe;
}

public class UE9Aufgabe15 {

	public static void main(String[] args) {
		// Initialisierungen
		final int GROESSE = 20;
		char[] spielfeld = new char[GROESSE];
		for (int i = 0; i < spielfeld.length; i++) {
			spielfeld[i] = '.';
		}
		
		print(spielfeld);
		int spieler = 0;
		while (spielzugMoeglich(spielfeld)) {
			Spielzug zug = spielzugEingeben(spielfeld, spieler);
			spielfeld[zug.index] = zug.buchstabe; // Spielzug ausfuehren
			print(spielfeld);
			if (spielende(spielfeld)) {
				System.out.println("Spieler " + (spieler + 1)
						+ " hat gewonnen!");
				return;
			}
			spieler = (spieler + 1) % 2; // Spielerwechsel
		}
		System.out.println("Unentschieden!");

	}

	static boolean spielzugMoeglich(char[] spielfeld) {
		for (int i = 0; i < spielfeld.length; i++) {
			if (spielfeld[i] == '.') {
				return true;
			}
		}
		return false;
	}

	static Spielzug spielzugEingeben(char[] spielfeld, int spieler) {
		Spielzug zug = new Spielzug();
		System.out.println("Spieler " + (spieler + 1) + " ist am Zug!");
		zug.index = IO.readInt("Index eingeben: ");
		while (zug.index < 0 || zug.index >= spielfeld.length
				|| spielfeld[zug.index] != '.') {
			zug.index = IO.readInt("Ungueltiger Index! Index eingeben: ");
		}
		zug.buchstabe = IO.readChar("S oder O eingeben: ");
		while (zug.buchstabe != 'S' && zug.buchstabe != 'O') {
			zug.buchstabe = IO
					.readChar("Ungueltiger Buchstabe! S oder O eingeben: ");
		}
		return zug;
	}

	static boolean spielende(char[] spielfeld) {
		return new String(spielfeld).contains("SOS");
	}

	static void print(char[] spielfeld) {
		System.out.println(new String(spielfeld));
	}

}
