class FachNote { // Note zu einem Fach
	String fachName;
	int note;
}

class Schueler { // Schueler mit Faechern und Noten
	String name;
	FachNote[] faecherNoten;
}

public class UE9Aufgabe2 {

	public static void main(String[] args) {

		// Daten einlesen
		int anzahlSchueler = IO
				.readInt("Anzahl der Schler einer Schulklasse: ");
		int anzahlFaecher = IO.readInt("Anzahl der Fcher: ");

		Schueler[] schueler = new Schueler[anzahlSchueler];
		String[] faecher = new String[anzahlFaecher];

		// Faecher einlesen (ohne Fehlerkonktrolle)
		for (int f = 0; f < anzahlFaecher; f++) {
			faecher[f] = IO.readString("Name von Fach " + (f + 1) + ": ");
		}

		// Schueler Fachnoten einlesen (ohne Fehlerkontrolle)
		for (int s = 0; s < anzahlSchueler; s++) {
			schueler[s] = new Schueler();
			schueler[s].name = IO.readString("Name des Schlers: ");
			schueler[s].faecherNoten = new FachNote[anzahlFaecher];
			for (int f = 0; f < anzahlFaecher; f++) {
				schueler[s].faecherNoten[f] = new FachNote();
				schueler[s].faecherNoten[f].fachName = faecher[f];
				schueler[s].faecherNoten[f].note = IO.readInt("Note im Fach "
						+ faecher[f] + ": ");
			}
		}

		// Abfrage
		while (true) {
			String fach = IO.readString("Fach: ");

			// Durchschnittsnote des Faches berechnen
			double durchschnittsnote = 0.0;
			int besteNote = 6;
			for (int s = 0; s < anzahlSchueler; s++) {
				for (int f = 0; f < anzahlFaecher; f++) {
					if (schueler[s].faecherNoten[f].fachName.equals(fach)) {
						durchschnittsnote += schueler[s].faecherNoten[f].note;
						if (schueler[s].faecherNoten[f].note < besteNote) {
							besteNote = schueler[s].faecherNoten[f].note;
						}
					}
				}
			}
			durchschnittsnote /= anzahlSchueler;
			System.out.println("Durchschnittsnote = " + durchschnittsnote);

			// Beste Schueler des Faches ermitteln
			for (int s = 0; s < anzahlSchueler; s++) {
				for (int f = 0; f < anzahlFaecher; f++) {
					if (schueler[s].faecherNoten[f].fachName.equals(fach)) {
						if (schueler[s].faecherNoten[f].note == besteNote) {
							System.out.println("Bester Schueler = "
									+ schueler[s].name);
						}
					}
				}
			}
		}
	}
}
